#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <ctype.h>
#include <tchar.h>
#include <iostream.h>
#include <process.h>
#include <stdlib.h>
#include <aclapi.h>
#include "kmem.h"
#include "recursos.h"

HWND g_hwnd, g_hwndEdit;
int flag;

//
// Cargo de forma dinmica las funciones en NTDLL
//

NTSTATUS (__stdcall *NtOpenSection)(
		OUT PHANDLE  SectionHandle,
		IN ACCESS_MASK  DesiredAccess,
		IN POBJECT_ATTRIBUTES  ObjectAttributes
		);

VOID  (__stdcall *NtClose)(
		IN HANDLE  Handle
		);

VOID (__stdcall *RtlInitUnicodeString)(
		IN OUT PUNICODE_STRING  DestinationString,
		IN PCWSTR  SourceString
		);

//--------------------------------------------------------
//
// LocateNtdllEntryPoints
//
// Busca los entry points para las funciones de arriba
//
//--------------------------------------------------------
BOOLEAN LocateNtdllEntryPoints()
{
	if( !(RtlInitUnicodeString = (void (__stdcall *)(struct _UNICODE_STRING *,const unsigned short *)) GetProcAddress( GetModuleHandle("ntdll.dll"),
			"RtlInitUnicodeString" )) ) {

		return FALSE;
	}

	if( !(NtOpenSection = (long (__stdcall *)(void ** ,unsigned long,struct _OBJECT_ATTRIBUTES *)) GetProcAddress( GetModuleHandle("ntdll.dll"),
			"NtOpenSection" )) ) {

		return FALSE;
	}

	if( !(NtClose = (void (__stdcall *)(void *)) GetProcAddress( GetModuleHandle("ntdll.dll"),
			"NtClose" )) ) {

		return FALSE;
	}

	return TRUE;
}

BOOL Dlg_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lparam)
{
   SetClassLong(hwnd, GCL_HICON, (LONG) LoadIcon(GetWindowInstance(hwnd), MAKEINTRESOURCE(IDI_SACCO)));
   g_hwnd = hwnd;
   g_hwndEdit = GetDlgItem(hwnd, IDC_EDIT1);
   SetWindowText(g_hwndEdit, "\\Device\\PhysicalMemory was not changed yet.");

   return 1;
}

void Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtrl, UINT codeNotify)
{
   OBJECT_ATTRIBUTES ObAttributes;
   NTSTATUS          ntS;
   HANDLE            Section = NULL;

   DWORD                Res;
   PACL                 OldDacl=NULL, NewDacl=NULL;
   PSECURITY_DESCRIPTOR SecDesc=NULL;
   EXPLICIT_ACCESS      Access;


   UNICODE_STRING	    physmemString;
   WCHAR			    physmemName[] = L"\\device\\physicalmemory";

	switch(id)
	{
		case IDOK:
			if (flag != 666)
			{
				memset(&Access, 0, sizeof(EXPLICIT_ACCESS));
				//
				// Cargar los entry points
				//
				if( !LocateNtdllEntryPoints() ) {
					MessageBox(0,"Unable to locate NTDLL entry points.","Changing \\Device\\PhysicalMemory !!!", 0);
				  goto cleanup;
				}

				RtlInitUnicodeString( &physmemString, physmemName );	
				InitializeObjectAttributes(&ObAttributes,
										  &physmemString,
										  OBJ_CASE_INSENSITIVE | OBJ_KERNEL_HANDLE,
										  NULL,
										  NULL);

				/////////////////////
				// 1 - Abrir un handle a \Device\PhysicalMemory
				ntS = NtOpenSection(&Section, WRITE_DAC | READ_CONTROL, &ObAttributes);
				if (ntS != STATUS_SUCCESS) {
					MessageBox(0,"Error abriendo Section","Changing \\Device\\PhysicalMemory !!!",0);
					goto cleanup;
				}
   
				/////////////////////
				// 2 - Obtener un copia del descriptor de seguridad
				Res = GetSecurityInfo(Section, SE_KERNEL_OBJECT, 
									  DACL_SECURITY_INFORMATION, NULL, NULL, &OldDacl,
									  NULL, &SecDesc);
				if (Res != ERROR_SUCCESS) {
					MessageBox(0,"Error obteniendo descriptor de seguridad","Changing \\Device\\PhysicalMemory !!!",0);
					goto cleanup;
				}

				Access.grfAccessPermissions = SECTION_MAP_WRITE;
				Access.grfAccessMode        = GRANT_ACCESS;
				Access.grfInheritance       = NO_INHERITANCE;
				Access.Trustee.MultipleTrusteeOperation = NO_MULTIPLE_TRUSTEE;
				// Cambiar esta informacin para permitir acceso a un grupo u otro usuario
				Access.Trustee.TrusteeForm  = TRUSTEE_IS_NAME;
				Access.Trustee.TrusteeType  = TRUSTEE_IS_USER;
				Access.Trustee.ptstrName = "CURRENT_USER";

				/////////////////////
				// 3 - Agregar una ACE con permisos de escritura a la ACL actual
				Res = SetEntriesInAcl(1, &Access, OldDacl, &NewDacl);
				if (Res != ERROR_SUCCESS) {
					MessageBox(0,"Error creando una nueva ACL","Changing \\Device\\PhysicalMemory !!!",0);
					goto cleanup;
				}

				/////////////////////
				// 4 - Actualizar el descriptor de seguridad
				Res = SetSecurityInfo(Section, SE_KERNEL_OBJECT,
									  DACL_SECURITY_INFORMATION, NULL, NULL, NewDacl, 
									  NULL);
				if (Res != ERROR_SUCCESS) {
					MessageBox(0,"Error actualizando ACL","Changing \\Device\\PhysicalMemory !!!",0);
					goto cleanup;
				}

				/////////////////////
				// 5 - Cerrar la seccin
				if (Section)
					NtClose(Section);

				/////////////////////
				// Ahora que ya agregamos los permisos de escritura, intentamos abrir una seccin
				// para tal fin. Si podemos abrirla sin problemas, significa que anteriormente
				// cambiamos con xito los permisos de escritura en la memoria fsica.
				ntS = NtOpenSection(&Section, SECTION_MAP_READ|SECTION_MAP_WRITE, &ObAttributes);

				if (ntS != STATUS_SUCCESS) {
					if (ntS == STATUS_ACCESS_DENIED) {
						MessageBox(0,"Error: access denied to open \\Device\\PhysicalMemory for r/w","Changing \\Device\\PhysicalMemory !!!",0);
						goto cleanup;
					}
					else {
						MessageBox(0,"Error: abriendo NtOpenSection","Changing \\Device\\PhysicalMemory !!!",0);
						goto cleanup;
				   }
				}

				MessageBox(0,"\\Device\\PhysicalMemory chmoded","Changing \\Device\\PhysicalMemory !!!",0);
				SetWindowText(g_hwndEdit, "\\Device\\PhysicalMemory is changed.");
		 		flag = 666;
 				break;
			}
			else
				MessageBox(hwnd,"\\Device\\PhysicalMemory was changed previously","Changing \\Device\\PhysicalMemory !!!", MB_ICONEXCLAMATION);
				break;

		case IDHELP:
      		MessageBox(hwnd, "Desde las profundidades del abismo...\n\r\n                  SACCOPHARYNX\n\r\n http://www.iespana.es/saccopharynx", "Changing \\Device\\PhysicalMemory !!!",0);
			break;

		case IDCANCEL:
			EndDialog(hwnd,id);
			break;
   }
cleanup:
	/////////////////////
	// Cerrar la seccin abierta para escritura
	if (Section)
		NtClose(Section);
	if (SecDesc)
		LocalFree(SecDesc);
}

BOOL CALLBACK Dlg_Proc (HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
   switch(uMsg)
   {
   	HANDLE_MSG(hwnd, WM_COMMAND, Dlg_OnCommand);
      HANDLE_MSG(hwnd, WM_INITDIALOG, Dlg_OnInitDialog);
	}
	return false;
}

int WINAPI WinMain(HINSTANCE hinstExe, HINSTANCE hinstPrev,  LPTSTR pszCmdLine, int nCmdShow)
{
   DialogBox(hinstExe, MAKEINTRESOURCE(IDD_VENTANA), NULL, Dlg_Proc);
   return(0);
}
